/* Fesslix - Stochastic Analysis
 * Copyright (C) 2010-2012 Wolfgang Betz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef fesslix_flxdefault_H
#define fesslix_flxdefault_H

  
#include "flxglobal.h"

const tuint DEFAULT_FPC_PREC = 6;
const tuint DEFAULT_FPC_TYPE = 2;
const tdouble DEFAULT_FPC_BVALU = 1e4;
const tdouble DEFAULT_FPC_BVALL = 1e-2;
const bool DEFAULT_FPC_DEL0 = true;
const bool DEFAULT_FPC_DELP = true;
const bool DEFAULT_FLX_PRGBAR = true;

const char DEFAULT_GAUSS_FILE [] = "{default}";
const tuint DEFAULT_GAUSS_MAXNUMB = 45;
const tuint DEFAULT_GAUSS_NUMB = 20;

const tuint DEFAULT_LEGENDRE_NUMB = 10;

const bool DEFAULT_LOG_INPUT=true;
const char DEFAULT_LOG_FILE [] = "{default}";
const bool DEFAULT_LOG_OUTPUT = true;
const bool DEFAULT_LOG_DO_LOGINFO = false;
const int DEFAULT_LOG_LEVEL = 4;
const bool DEFAULT_LOG_TRUNC = false;

const tuint DEFAULT_MT19937_INIT_CALLS = 1000;
const bool DEFAULT_MT19937_INIT_RAND = true;
const bool DEFAULT_MT19937_INIT_SEED = false;
const tuint DEFAULT_MT19937_INIT_SEEDVALUE = 0;

const tnlong DEFAULT_EXP_NUM_INTERVALS_1D = tnlong(1e4);
const tnlong DEFAULT_EXP_NUM_SAMPLES_1D = tnlong(3e5);
const tdouble DEFAULT_EXP_NUM_DIFF_REDISTRIBUTE_1D = 0.9;
const tdouble DEFAULT_EXP_NUM_LBOUND_1D = -38;
const tdouble DEFAULT_EXP_NUM_UBOUND_1D = 38;
const tnlong DEFAULT_EXP_NUM_RND_MOMENTS = 15;
const tnlong DEFAULT_EXP_NUM_RND_MOMENTS_CENTRAL = 15;
const tdouble DEFAULT_EXP_NUM_BOUND_MCI = 38;
const tnlong DEFAULT_EXP_NUM_INTERVALS_MCI = 608;
const tnlong DEFAULT_EXP_NUM_SMPPERINTERVAL_MCI = 1000;
const tnlong DEFAULT_EXP_NUM_SMP_REDISTRIBUTE_MCI = tnlong(1e7);
const tdouble DEFAULT_EXP_NUM_DIFF_REDISTRIBUTE_MCI = 0.2;

const tdouble DEFAULT_TOL = 1e-14;

#if FLX_PAUSE_AT_END
  const bool DEFAULT_PAUSE_AT_END = true;
#else
  const bool DEFAULT_PAUSE_AT_END = false;
#endif

#endif // fesslix_flxdefault_H

