/* Fesslix - Stochastic Analysis
 * Copyright (C) 2010-2012 Wolfgang Betz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef fesslix_flxglobaldef_H
#define fesslix_flxglobaldef_H

#include "config.h"

#define RETURN_SUCCESS 0
#define RETURN_ERROR 1

typedef double tdouble;
typedef tdouble* tdoublePtr;
typedef float tfloat;
typedef unsigned long tulong;	// for very very long numbers
typedef unsigned int tnlong;	// for node numbering (and dof numbering)
typedef unsigned int tuint;
typedef const tuint* const_tuintPtr;

#if FLX_DEBUG_COUT
  #include <iostream>
  inline void debug(std::string dstr) { std::cout << dstr << std::endl;}
#endif



#endif // fesslix_flxglobaldef_H
