/* Fesslix - Stochastic Analysis
 * Copyright (C) 2010-2012 Wolfgang Betz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 */

#include "flxlibs.h"

#define fesslix_flxlibs_CPP
#include "flxbn/flxbn.h"

using namespace std;

bool FlxObjReadLoadLib::sfem = false;
bool FlxObjReadLoadLib::rnd = false;
bool FlxObjReadLoadLib::flxbn = false;

FlxObjBase* FlxObjReadLoadLib::read() {
  char c1 = 34;
  reader->getChar(c1,false);
  string lname = reader->getWord(true,false);
  reader->getChar(c1,false);
  
  FlxCreateObjReaders* cor=NULL;
  if (lname=="ssfem") {
    if (sfem) {
      ostringstream ssV;
      ssV << "Library '" << lname << "' has already been loaded.";
      throw FlxException_NeglectInInteractive("FlxObjReadLoadLib::read_1", ssV.str(), reader->getCurrentPos());
    } else {
      sfem = true;
      cor = new sfem::FlxCreateObjReaders_SFEM();
      cor->createFunReaders( data );
      cor->createObjReaders( objReadBox );
      delete cor;
    }
  } else if (lname=="rnd") {
    if (rnd) {
      ostringstream ssV;
      ssV << "Library '" << lname << "' has already been loaded.";
      throw FlxException_NeglectInInteractive("FlxObjReadLoadLib::read_1", ssV.str(), reader->getCurrentPos());
    } else {
      rnd = true;
      cor = new FlxCreateObjReaders_RND();
      cor->createFunReaders( data );
      cor->createObjReaders( objReadBox );
      delete cor;
    }
  } else if (lname=="flxbn") {
    if (flxbn) {
      ostringstream ssV;
      ssV << "Library '" << lname << "' has already been loaded.";
      throw FlxException_NeglectInInteractive("FlxObjReadLoadLib::read_2", ssV.str(), reader->getCurrentPos());
    } else {
      rnd = true;
      cor = new flxbn::FlxCreateObjReaders_FLXBN();
      cor->createFunReaders( data );
      cor->createObjReaders( objReadBox );
      delete cor;
    }
  } else {
    ostringstream ssV;
    ssV << "Library '" << lname << "' does not exist.";
    throw FlxException_NeglectInInteractive("FlxObjReadLoadLib::read_3", ssV.str(), reader->getCurrentPos());
  }
  
  GlobalVar.slog(3) << "loadlib: library '" << lname << "' loaded." << std::endl;
  FlxObjBase* obj1 = new FlxObjDummy(); 
  return obj1;
}

