/* Fesslix - Stochastic Analysis
 * Copyright (C) 2010-2012 Wolfgang Betz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef fesslix_flxmtxfun_fun_read_H
#define fesslix_flxmtxfun_fun_read_H

#include "flxmtxfun_fun_calc.h"

class FunReadMtxFunNewMtx : public FunReadMtxFunBase {
  public:
    FunMtxBase* read ( bool errSerious );
};

class FunReadMtxFunPow : public FunReadMtxFunBase {
  public:
    FunMtxBase* read ( bool errSerious );
};

class FunReadMtxFunTranspose : public FunReadMtxFunBase {
  public:
    FunMtxBase* read ( bool errSerious );
};

class FunReadMtxFunFilter : public FunReadMtxFunBase {
  public:
    FunMtxBase* read ( bool errSerious );
};

class FunReadMtxFunSeq : public FunReadMtxFunBase {
  public:
    FunMtxBase* read ( bool errSerious );
};

class FunReadMultVecCoeff : public FunReadMtxFunBase {
  public:
    FunMtxBase* read ( bool errSerious );
};

//=================== FlxFunction - Part ==========================


class FunReadFunMax : public FunReadFunBase_MtxConst {
  public:
    FunBase* read ( bool errSerious ) { return new FunMax( read_para(0,errSerious) ); }
};

class FunReadFunMin : public FunReadFunBase_MtxConst {
  public:
    FunBase* read ( bool errSerious ) { return new FunMin( read_para(0,errSerious) ); }
};

class FunReadFunMtxCoeff : public FunReadFunBase_MtxConst {
  public:
    FunBase* read ( bool errSerious );
};

class FunReadFunMtxRows : public FunReadFunBase_MtxConst {
  public:
    FunBase* read ( bool errSerious ) { return new FunMtxRows( read_para(1,errSerious) ); }
};

class FunReadFunMtxCols : public FunReadFunBase_MtxConst {
  public:
    FunBase* read ( bool errSerious ) { return new FunMtxCols( read_para(1,errSerious) ); }
};

class FunReadFunMtxSum : public FunReadFunBase_MtxConst {
  public:
    FunBase* read ( bool errSerious ) { return new FunMtxSum( read_para(1,errSerious) ); }
};


#endif // fesslix_flxmtxfun_fun_read_H


