/* Fesslix - Stochastic Analysis
 * Copyright (C) 2010-2012 Wolfgang Betz 
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef fesslix_flxmtxfun_ope_read_H
#define fesslix_flxmtxfun_ope_read_H

#include "flxmtxfun_ope_calc.h"

/**
* @brief arithmetic read class of SMtxValue
*/
class FunMtxReadValue : public FunMtxReadBase {
  private:
    FunMtxBase* read ( bool errSerious );
  public:
    FunMtxReadValue () : FunMtxReadBase(1000) {}
};

/**
* @brief considers brackets in arithmetic functions
*/
class FunMtxReadBracket : public FunMtxReadBase {
  private:
    FunMtxBase* read ( bool errSerious );
  public:
    FunMtxReadBracket () : FunMtxReadBase(1100) {}
};

/**
* @brief arithmetic read class of FunMtxAdd
*/
class FunMtxReadAdd : public FunMtxReadBase {
  private:
    FunMtxBase* read ( bool errSerious );
  public:
    FunMtxReadAdd () : FunMtxReadBase(40) {}
};

/**
* @brief arithmetic read class of FunMtxMult
*/
class FunMtxReadMult : public FunMtxReadBase {
  private:
    FunMtxBase* read ( bool errSerious );
  public:
    FunMtxReadMult () : FunMtxReadBase(50) {}
};

/**
* @brief arithmetic read class for 'words' (variables, funnctions, constants)
*/
class FunMtxReadWord : public FunMtxReadBase, public FlxMtxBoxBase {
  private:
    FunMtxBase* read ( bool errSerious );
  public:
    FunMtxReadWord () : FunMtxReadBase(1010) {};
};


#endif // fesslix_flxmtxfun_ope_read_H